//  Created by Joe Becker on 3/7/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.

#import <Cocoa/Cocoa.h>
#import "GraphView.h"


@interface ColorGraphView : GraphView
{
    NSColor *axesColor;
    NSColor *labelColor;
	NSColor *flagColor;
    NSColor *predictedColor;
	NSColor *measuredColor;
}

- (BOOL)isOpaque;
- (NSColor *)colorForTag:(int)aTag;
- (void)setObjectsToColor:(NSColor *)theColor forTag:(int)aTag;
- (void)addGraphElement:(id)element;

- (IBAction)setObjectsToColor:(id)sender;


// Dragging Support

- (int)tagAtPoint:(NSPoint)pt;
- (unsigned int)draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int)draggingUpdated:(id <NSDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender;

// Chapter 21 - Defaults

+ (void) initialize;
- (void) awakeFromNib;


@end

NSData *DataForColor(NSColor *aColor);
NSColor *ColorForData(NSData *data);

