//  Created by Joe Becker on 3/7/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.

#include <math.h>
#import <Cocoa/Cocoa.h>
#import "define.h"
#import "GmtShipTrackRecord.h"


@interface GmtShipTrack : NSObject {
	NSMutableArray *gmtShipTrackRecordList;

	GmtShipTrackRecord *max;
	GmtShipTrackRecord *min;
	GmtShipTrackRecord *mean;
	GmtShipTrackRecord *stdDev;
	GmtShipTrackRecord *slope;
	GmtShipTrackRecord *offset;

	GmtShipTrackRecord *numGood;
	GmtShipTrackRecord *sumOfX;
	GmtShipTrackRecord *sumOfXSqr;
	GmtShipTrackRecord *sumOfY;
	GmtShipTrackRecord *sumOfYSqr;
	GmtShipTrackRecord *sumOfXY;
	GmtShipTrackRecord *sumOfDeltaY;
	GmtShipTrackRecord *sumOfXDeltaY;
	GmtShipTrackRecord *sumOfDeltaYSqr;
	
//	FIXME: to skip, or not skip, firstLineOfFile ...
//	NSString *firstLineOfFile;
//	NSString *secondLineOfFile;
	
	double		carterCount;
}

- (id)readFromPath:(NSString *)filePath;
- (id)writeToPath:(NSString *)filePath;

- (id)gmtShipTrackRecordList;

- (id)setDoubleWithNaN:(id)cell:(double)data;

- (GmtShipTrackRecord *)maxRecordOf:(GmtShipTrackRecord *)a:(GmtShipTrackRecord *)b;
- (GmtShipTrackRecord *)minRecordOf:(GmtShipTrackRecord *)a:(GmtShipTrackRecord *)b;

- (void)calculateSumsForStats;

- (GmtShipTrackRecord *)max;
- (GmtShipTrackRecord *)min;
- (GmtShipTrackRecord *)mean;
- (GmtShipTrackRecord *)stdDev;
- (GmtShipTrackRecord *)slope;
- (GmtShipTrackRecord *)offset;
- (GmtShipTrackRecord *)numGood;

- (GmtShipTrackRecord *)objectAt:(int)dataField:(float)x:(float)y;

- (double)carterCount;
- (double)setCarterCount:(double)cnt;

- (void)addCarterCorrection;
- (void)subCarterCorrection;

- (NSRect)extent:(int)field;

@property (retain,getter=numGood) GmtShipTrackRecord *numGood;
@property (retain) GmtShipTrackRecord *sumOfDeltaY;
@property (retain,getter=slope) GmtShipTrackRecord *slope;
@property (retain) GmtShipTrackRecord *sumOfXY;
@property (retain) GmtShipTrackRecord *sumOfY;
@property (retain) GmtShipTrackRecord *sumOfX;
@property (retain,getter=max) GmtShipTrackRecord *max;
@property (retain) GmtShipTrackRecord *sumOfYSqr;
@property (retain,getter=min) GmtShipTrackRecord *min;
@property (retain) GmtShipTrackRecord *sumOfXSqr;
@property (retain,getter=stdDev) GmtShipTrackRecord *stdDev;
@property (retain,getter=offset) GmtShipTrackRecord *offset;
@property (retain) GmtShipTrackRecord *sumOfDeltaYSqr;
@property (retain) GmtShipTrackRecord *sumOfXDeltaY;
@property (retain,getter=mean) GmtShipTrackRecord *mean;
@end
