//  Created by Joe Becker on 3/7/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.

#import <Cocoa/Cocoa.h>
#import "GraphView.h"
#import "Controller.h"
#import "GMTShipTrack.h"

@interface Segment:NSObject <GraphViewElement>
{
	id						view;
	NSPoint					start;
    NSPoint					center;
    NSPoint					end;
    NSColor					*color;
    int						tag;
	int						lineType;
	GmtShipTrackRecord		*shipTrackRecord;
}

- initFrom:(NSPoint)theStart to:(NSPoint)theEnd view:(id)theView record:(GmtShipTrackRecord *)obj;
- (NSPoint)start;
- (NSPoint)end;
- (NSPoint)center;
- (void)setLineType:(int)aType;
- (int)lineType;
- (GmtShipTrackRecord *)shipTrackRecord;
- (void)setShipTrackRecord:(GmtShipTrackRecord *)aShipTrackRecord;
- (void)addDashStyleToPath:(NSBezierPath *)thePath;

@property (retain) id						view;
@property (getter=lineType,setter=setLineType:) int						lineType;
@property (assign,getter=shipTrackRecord,setter=setShipTrackRecord:) GmtShipTrackRecord		*shipTrackRecord;
@property (getter=tag,setter=setTag:) int						tag;
@end
