//  Created by Joe Becker on 3/7/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.

#import <Cocoa/Cocoa.h>
#import "ColorGraphView.h"


@interface TrackingGraphView : ColorGraphView
{
    IBOutlet id xCell;
    IBOutlet id yCell;
    IBOutlet id tCell;
    NSTrackingRectTag trackingRectTag;
    NSMutableArray *annotations;
	int dataTypeBeingPlotted;
	
	// Clicking and dragging
	NSPoint		mouseDownPoint;
	NSPoint		mouseUpPoint;
	NSRect		selectedRect;
	BOOL		weBeFlagging;

	float				xAtCursor;
	float				yAtCursor;
	float				tAtCursor;
	GmtShipTrackRecord	*objAtCursor;
	
	int			tagOfInterest;
	double		distanceToLine;
	BOOL		hotSpotIsCenterOfSegment;
	BOOL		hotSpotFound;
	BOOL		dataMissingLastTime;
}

- (NSRect) selectedRect;

- (BOOL)isOpaque;

- (void)addAnnotation:(id)obj;
- (id)initWithFrame:(NSRect)frame;
- (int)dataTypeBeingPlotted;
- (void)mouseEntered:(NSEvent *)theEvent;
- (void)mouseExited:(NSEvent *)theEvent;
- (void)moveCursorToTime:(float)time;
- (void)moveCursorToRecord:(GmtShipTrackRecord *)obj;
- (void)moverCursorToHotSpot:(NSPoint)hotSpot;
- (void)mouseMoved:(NSEvent *)theEvent;
- (void)mouseUp:(NSEvent *)theEvent;
- (void)mouseDragged:(NSEvent *)theEvent;
- (void)removeAnnotations;
- (void)zoomToRect:(NSRect)rect;
- (IBAction)zoomOut:(id)sender;
- (IBAction)zoomIn:(id)sender;
- (void)pageBy:(double)deltaX:(double)deltaY;
- (IBAction)pageLeft:(id)sender;
- (IBAction)pageRight:(id)sender;
- (IBAction)stretchX:(id)sender;
- (IBAction)stretchY:(id)sender;
- (IBAction)shrinkX:(id)sender;
- (IBAction)shrinkY:(id)sender;
- (IBAction)pageToFirst:(id)sender;
- (IBAction)pageToLast:(id)sender;

- (void)dataMissing;


@property BOOL		weBeFlagging;
@property float				xAtCursor;
@property (retain) id yCell;
@property (retain) NSMutableArray *annotations;
@property BOOL		dataMissingLastTime;
@property int			tagOfInterest;
@property (retain) GmtShipTrackRecord	*objAtCursor;
@property (retain) id xCell;
@property (getter=dataTypeBeingPlotted) int dataTypeBeingPlotted;
@property BOOL		hotSpotIsCenterOfSegment;
@property (retain) id tCell;
@property float				yAtCursor;
@property BOOL		hotSpotFound;
@property float				tAtCursor;
@property NSTrackingRectTag trackingRectTag;
@property double		distanceToLine;
@end
